#include <iostream>
#include <fstream>
#include <cstdlib> // exit()
#include <vector>
#include <string.h>
#include <sstream>
#include <windows.h>
#include <ctype.h>

const std::string g_flat_pattern[] = {
						  "A_gFlat_part_1_AND_green:", // right
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_1_AND_cyan:",  // left
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_2_AND_green:", // right
                          "A_gFlat_part_2_AND_red:",   // up
                          "A_gFlat_part_3_XOR_red:",   // up
                          "A_gFlat_part_4_OR_cyan:",   // left
                          "A_gFlat_part_4_OR_red:"};   // up

const std::string d_flat_pattern[] = {
						  "B_dFlat_part_1_AND_red:", // up
                          "B_dFlat_part_1_AND_blue:",   // straight
                          "B_dFlat_part_1_AND_red:",  // up
                          "B_dFlat_part_1_AND_cyan:",   // left
                          "B_dFlat_part_2_AND_red:", // up
                          "B_dFlat_part_2_AND_cyan:",   // left
                          "B_dFlat_part_3_XOR_blue:",   // straight
                          "B_dFlat_part_4_OR_red:",   // up
                          "B_dFlat_part_4_OR_cyan:"};   // left

const std::string a_flat_pattern[] = {
	                      "C_aFlat_part_1_AND_cyan:", // left
                          "C_aFlat_part_1_AND_yellow:",   // down
                          "C_aFlat_part_1_AND_blue:",  // straight
                          "C_aFlat_part_1_AND_red:",   // up
                          "C_aFlat_part_2_AND_cyan:", // left
                          "C_aFlat_part_2_AND_red:",   // up
                          "C_aFlat_part_3_XOR_yellow:",   // down
                          "C_aFlat_part_4_OR_blue:",   // straight
                          "C_aFlat_part_4_OR_red:"};   // up

const std::string e_flat_pattern[] = {
	                      "D_eFlat_part_1_AND_red:", // up
                          "D_eFlat_part_1_AND_red:",   // up
                          "D_eFlat_part_1_AND_yellow:",  // down
                          "D_eFlat_part_1_AND_blue:",   // straight
                          "D_eFlat_part_2_AND_red:", // up
                          "D_eFlat_part_2_AND_blue:",   // straight
                          "D_eFlat_part_3_XOR_red:",   // up
                          "D_eFlat_part_4_OR_yellow:",   // down
                          "D_eFlat_part_4_OR_blue:"};   // straight


const std::string b_flat_pattern[] = {
	                      "E_bFlat_part_1_AND_blue:", // straight
                          "E_bFlat_part_1_AND_green:",   // right
                          "E_bFlat_part_1_AND_red:",  // up
                          "E_bFlat_part_1_AND_yellow:",   // down
                          "E_bFlat_part_2_AND_blue:", // straight
                          "E_bFlat_part_2_AND_yellow:",   // down
                          "E_bFlat_part_3_XOR_green:",   // right
                          "E_bFlat_part_4_OR_red:",   // up
                          "E_bFlat_part_4_OR_yellow:"};   // down

const std::string F_pattern[] = {
	                      "F_part_1_AND_yellow:", // down
                          "F_part_1_AND_red:",   // up
                          "F_part_1_AND_green:",  // right
                          "F_part_1_AND_red:",   // up
                          "F_part_2_AND_yellow:", // down
                          "F_part_2_AND_red:",   // up
                          "F_part_3_XOR_red:",   // up
                          "F_part_4_OR_green:",   // right
                          "F_part_4_OR_red:"};   // up

const std::string C_pattern[] = {
	                      "G_C_part_1_AND_red:", // up
                          "G_C_part_1_AND_blue:",   // straight
                          "G_C_part_1_AND_red:",  // up
                          "G_C_part_1_AND_green:",   // right
                          "G_C_part_2_AND_red:", // up
                          "G_C_part_2_AND_green:",   // right
                          "G_C_part_3_XOR_blue:",   // straight
                          "G_C_part_4_OR_red:",   // up
                          "G_C_part_4_OR_green:"};   // right

const std::string G_pattern[] = {
	                      "H_G_part_1_AND_green:", // right
                          "H_G_part_1_AND_orange:",   // up and down
                          "H_G_part_1_AND_blue:",  // straight
                          "H_G_part_1_AND_red:",   // up
                          "H_G_part_2_AND_green:", // right
                          "H_G_part_2_AND_red:",   // up
                          "H_G_part_3_XOR_orange:",   // up and down
                          "H_G_part_4_OR_blue:",   // straight
                          "H_G_part_4_OR_red:"};   // up

const std::string D_pattern[] = {
	                      "I_part_1_AND_red:", // up
                          "I_part_1_AND_violet:",   // around
                          "I_part_1_AND_orange:",  // up and down
                          "I_part_1_AND_blue:",   // straight
                          "I_part_2_AND_red:", // up
                          "I_part_2_AND_blue:",   // straight
                          "I_part_3_XOR_violet:",   // around
                          "I_part_4_OR_orange:",   // up and down
                          "I_part_4_OR_blue:"};   // straight

const std::string A_pattern[] = {
	                      "J_A_part_1_AND_blue:", // straight
                          "J_A_part_1_AND_green:",   // right
                          "J_A_part_1_AND_violet:",  // around
                          "J_A_part_1_AND_orange:",   // up and down
                          "J_A_part_2_AND_blue:", // straight
                          "J_A_part_2_AND_orange:",   // up and down
                          "J_A_part_3_XOR_green:",   // right
                          "J_A_part_4_OR_violet:",   // around
                          "J_A_part_4_OR_orange:"};   // up and down

const std::string E_pattern[] = {
	                      "K_E_part_1_AND_orange:", // up and down
                          "K_E_part_1_AND_red:",   // up
                          "K_E_part_1_AND_green:",  // right
                          "K_E_part_1_AND_violet:",   // around
                          "K_E_part_2_AND_orange:", // up and down
                          "K_E_part_2_AND_violet:",   // around
                          "K_E_part_3_XOR_red:",   // up
                          "K_E_part_4_OR_green:",   // right
                          "K_E_part_4_OR_violet:"};   // around

const std::string B_pattern[] = {
	                      "L_B_part_1_AND_violet:", // around
                          "L_B_part_1_AND_cyan:",   // left
                          "L_B_part_1_AND_red:",  // up
                          "L_B_part_1_AND_green:",   // right
                          "L_B_part_2_AND_violet:", // around
                          "L_B_part_2_AND_green:",   // right
                          "L_B_part_3_XOR_cyan:",   // left
                          "L_B_part_4_OR_red:",   // up
                          "L_B_part_4_OR_green:"};   // right

// I use this in the 12 pattern finding functions, to compare stings.
const std::string frequencies[] = {
									"466", // blue, keAS
                                   "415",  // cyan, keGS
                                   "415",  // cyan, keGS
                                   "415",  // cyan, keGS
                                   "415",  // cyan, keGS
                                   "415",  // cyan, keGS
                                   "349", // yellow, keF
                                   "277", // red, keCS
                                   "349", // yellow, keF
                                   "440",    // blue, keA
                                   "392",    // green, keG
                                   "261", // red, keC
                                   "261", // red, keC
                                   "349", // yellow, keF
                                   "493", // violet, keB
                                   "261", // red, keC
                                   "261", // red, keC
                                   "329", // orange, keE
                                   "311", // red, keDS
                                   "415",  // cyan, keGS
                                   "293", // red, keD
                                   "415",  // cyan, keGS
                                   "311", // red, keDS
                                   "369", // green, keFS
                                   "392",    // green, keG
                                   "392"};   // green, keG

using namespace std;

int count_up = 0;
int count_upnD = 0;
int count_down = 0;
int count_right_ = 0;
int count_left_ = 0;
int count_straight = 0;
int count_around = 0;

// This is used for playing sound
enum EFrequency {
	keRest = 0,
	keC = 262, keCS = 277, keD = 294, keDS = 311, keE = 330, keF = 349,
	keFS = 370, keG = 392, keGS = 415, keA = 440, keAS = 466, keB = 494,
};
enum EDuration {
	ke16th = 200, ke8th = (ke16th << 1), keQuart = (ke8th << 1),
	keHalf = (keQuart << 1), keWhole = (keQuart << 1)
};

class CmusicPattern {
public:
	CmusicPattern(unsigned int uiFrequency, unsigned int uiDuration)
		: muiFrequency(uiFrequency), muiDuration(uiDuration) {}
	void Play () {
		if (muiFrequency > 0) {
			Beep(muiFrequency, muiDuration);
		} else {
			Sleep(muiDuration);
		}
	}
	unsigned int muiFrequency;
	unsigned int muiDuration;
};

class CMelody {
public:
	void AddmusicPattern(unsigned int uiFrequency, unsigned int uiDuration) {
		mqmusicPatterns.push_back(CmusicPattern(uiFrequency, uiDuration));
	}
	void Play () {
		std::vector<CmusicPattern>::iterator qIter;
		for (qIter = mqmusicPatterns.begin(); qIter != mqmusicPatterns.end(); ++qIter) {
			qIter->Play();
		}
	}
	std::vector<CmusicPattern> mqmusicPatterns;
};

EFrequency g_flat_frequency_pattern [] = {keFS, keDS, keGS, keCS, keFS, keCS, keDS, keGS, keCS};
EFrequency d_flat_frequency_pattern [] = {keCS, keAS, keDS, keGS, keCS, keGS, keAS, keDS, keGS};
EFrequency a_flat_frequency_pattern [] = {keGS, keF, keAS, keDS, keGS, keDS, keF, keAS, keDS};
EFrequency e_flat_frequency_pattern [] = {keDS, keC, keF, keAS, keDS, keAS, keC, keF, keAS};
EFrequency b_flat_frequency_pattern [] = {keAS, keG, keC, keF, keAS, keF, keG, keC, keF};
EFrequency F_frequency_pattern [] = {keF, keD, keG, keC, keF, keC, keD, keG, keC};
EFrequency C_frequency_pattern [] = {keC, keA, keD, keG, keC, keG, keA, keD, keG};
EFrequency G_frequency_pattern [] = {keG, keE, keA, keD, keG, keD, keE, keA, keD};
EFrequency D_frequency_pattern [] = {keD, keRest, keE, keA, keD, keA, keRest, keE, keA};
EFrequency A_frequency_pattern [] = {keA, keFS, keRest, keE, keA, keE, keFS, keRest, keE};
EFrequency E_frequency_pattern [] = {keE, keCS, keFS, keRest, keE, keRest, keCS, keFS, keRest};
EFrequency B_frequency_pattern [] = {keRest, keGS, keCS, keFS, keRest, keFS, keGS, keCS, keFS};

int g_flat_duration [] = {ke8th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th,
ke8th + ke16th, ke8th + ke16th, ke16th, ke8th + ke16th};

int d_flat_duration [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th,
ke16th, ke16th, ke8th + ke16th, ke16th};

int a_flat_duration [] = {ke16th, ke8th, ke16th, ke8th + ke16th, ke16th,
ke8th + ke16th, ke8th, ke16th, ke8th + ke16th};

int e_flat_duration [] = {ke8th + ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th,
ke16th, ke8th + ke16th, ke8th, ke16th};

int b_flat_duration [] = {ke16th, ke8th, ke8th + ke16th, ke8th, ke16th,
ke8th, ke8th, ke8th + ke16th, ke8th};

int F_duration [] = {ke8th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th,
ke8th + ke16th, ke8th + ke16th, ke8th, ke8th + ke16th};

int C_duration [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke8th + ke16th,
ke8th, ke16th, ke8th + ke16th, ke8th};

int G_duration [] = {ke8th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th,
ke8th + ke16th, ke8th + ke16th, ke16th, ke8th + ke16th};

int D_duration [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th,
ke16th, ke16th, ke8th + ke16th, ke16th};

int A_duration [] = {ke16th, ke8th, ke16th, ke8th + ke16th, ke16th,
ke8th + ke16th, ke8th, ke16th, ke8th + ke16th};

int E_duration [] = {ke8th + ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th,
ke16th, ke8th + ke16th, ke8th, ke16th};

int B_duration [] = {ke16th, ke16th, ke8th + ke16th, ke8th, ke16th,
ke8th, ke16th, ke8th + ke16th, ke8th};


int g_flat_direction_pattern [] = {count_right_++, count_up++, count_left_++, count_up++,
count_right_++, count_up++, count_up++, count_left_++, count_up++};

int d_flat_direction_pattern [] = {count_up++, count_straight++, count_up++, count_left_++,
count_up++, count_left_++, count_straight++, count_up++, count_left_++};

int a_flat_direction_pattern [] = {count_left_++, count_down++, count_straight++, count_up++,
count_left_++, count_up++, count_down++, count_straight++, count_up++};

int e_flat_direction_pattern [] = {count_up++, count_up++, count_down++, count_straight++,
count_up++, count_straight++, count_up++, count_down++, count_straight++};

int b_flat_direction_pattern [] = {count_straight++, count_right_++, count_up++, count_down++,
count_straight++, count_down++, count_right_++, count_up++, count_down++};

int F_direction_pattern [] = {count_down++, count_up++, count_right_++, count_up++,
count_down++, count_up++, count_up++, count_right_++, count_up++};

int C_direction_pattern [] = {count_up++, count_straight++, count_up++, count_right_++,
count_up++, count_right_++, count_straight++, count_up++, count_right_++};

int G_direction_pattern [] = {count_right_++, count_upnD++, count_straight++, count_up++,
count_right_++, count_up++, count_upnD++, count_straight++, count_up++};

int D_direction_pattern [] = {count_up++, count_around++, count_upnD++, count_straight++,
count_up++, count_straight++, count_around++, count_upnD++, count_straight++};

int A_direction_pattern [] = {count_straight++, count_right_++, count_around++, count_upnD++,
count_straight++, count_upnD++, count_right_++, count_around++, count_upnD++};

int E_direction_pattern [] = {count_upnD++, count_up++, count_right_++, count_around++,
count_upnD++, count_around++, count_up++, count_right_++, count_around++};

int B_direction_pattern [] = {count_around++, count_left_++, count_up++, count_right_++,
count_around++, count_right_++, count_left_++, count_up++, count_right_++};

void findMatch(){

    int matching_char_one = 0;
	int matching_char_two = 0;
	int matching_char_three = 0;
	int matching_char_four = 0;
	int matching_char_five = 0;
	int matching_char_six = 0;
	int matching_char_seven = 0;
	int char_one_total = 0;
    int char_two_total = 0;
    int char_three_total = 0;
    int char_four_total = 0;
    int char_five_total = 0;
    int char_six_total = 0;
    int char_seven_total = 0;
    int char_one = 0;
	int char_two = 0;
	int char_three = 0;
	int char_four = 0;
	int char_five = 0;
	int char_six = 0;
	int char_seven = 0;
    string database;
    string inputSentence;
	string dataBaseSentence1;
    string dataBaseSentence2;
    string dataBaseSentence3;
    string dataBaseSentence4;
    string dataBaseSentence5;
    string dataBaseSentence6;
    string dataBaseSentence7;

	std::ifstream fin1("inputSentenceentence.txt"), fin2("holdDatabase.txt");
    if (!fin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }

    getline( fin1, inputSentence );

    while( getline( fin2, database ) ){
		matching_char_one = 0;
		char_one = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '1') {
				char_one++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_one++;
			}
		}

        if(matching_char_one > 2 && char_one > 0){
            dataBaseSentence1 = database;
			char_one_total = matching_char_one;
            break;
        }
        matching_char_one = 0;
        char_one = 0;
    }
    fin1.close();
    fin2.close();

    std::ifstream fin3("holdDatabase.txt");
    if (!fin3) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin3, database ) ){
		matching_char_two = 0;
		char_two = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '2') {
				char_two++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_two++;
			}
		}

        if(matching_char_two > 2 && char_two > 0){
            dataBaseSentence2 = database;
			char_two_total = matching_char_two;
            break;
        }
        matching_char_two = 0;
        char_two = 0;
    }
    fin3.close();

    std::ifstream fin4("holdDatabase.txt");
    if (!fin4) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin4, database ) ){
		matching_char_three = 0;
		char_three = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '3') {
				char_three++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_three++;
			}
		}

        if(matching_char_three > 2 && char_three > 0){
            dataBaseSentence3 = database;
			char_three_total = matching_char_three;
            break;
        }
        matching_char_three = 0;
        char_three = 0;
    }
    fin4.close();

    std::ifstream fin5("holdDatabase.txt");
    if (!fin5) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin5, database ) ){
		matching_char_four = 0;
		char_four = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '4') {
				char_four++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_four++;
			}
		}

        if(matching_char_four > 2 && char_four > 0){
            dataBaseSentence4 = database;
			char_four_total = matching_char_four;
            break;
        }
        matching_char_four = 0;
        char_four = 0;
    }
    fin5.close();

    std::ifstream fin6("holdDatabase.txt");
    if (!fin6) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin6, database ) ){
		matching_char_five = 0;
		char_five = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '5') {
				char_five++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_five++;
			}
		}

        if(matching_char_five > 2 && char_five > 0){
            dataBaseSentence5 = database;
			char_five_total = matching_char_five;
            break;
        }
        matching_char_five = 0;
        char_five = 0;
    }
    fin6.close();
			//////////////////////
    std::ifstream fin7("holdDatabase.txt");
    if (!fin7) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin7, database ) ){
		matching_char_six = 0;
		char_six = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '6') {
				char_six++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_six++;
			}
		}

        if(matching_char_six > 2 && char_six > 0){
            dataBaseSentence6 = database;
			char_six_total = matching_char_six;
            break;
        }
        matching_char_six = 0;
        char_six = 0;
    }
    fin7.close();
			//////////////////////
    std::ifstream fin8("holdDatabase.txt");
    if (!fin8) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( fin8, database ) ){
		matching_char_seven = 0;
		char_seven = 0;

        for (string::size_type a = 0; a < database.length(); ++a) {
			if (database[a] == '7') {
				char_seven++;
				break;
			}
        }

		for (string::size_type b = 0; b < inputSentence.length(); ++b) {
			if (database.find(inputSentence[b]) != string::npos && inputSentence[b] != ' ') {
				matching_char_seven++;
			}
		}

        if(matching_char_seven > 2 && char_seven > 0){
            dataBaseSentence7 = database;
			char_seven_total = matching_char_seven;
            break;
        }
        matching_char_seven = 0;
        char_seven = 0;
    }
    fin8.close();

	//if(char_one_total > char_two_total && (char_one_total > char_three_total) && (char_one_total > char_four_total)
      //&& (char_one_total > char_five_total)&& (char_one_total > char_six_total) && (char_one_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_one_total << ", Program response; " << endl
        << dataBaseSentence1;
/*______________________________________________________________________________________________*/
    //else if(char_two_total > char_one_total && (char_two_total > char_three_total) && (char_two_total > char_four_total)
    // && (char_two_total > char_five_total)&& (char_two_total > char_six_total) && (char_two_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_two_total <<  ", Program response; " << endl
        << dataBaseSentence2;
/*______________________________________________________________________________________________*/
    //else if(char_three_total > char_two_total && (char_three_total > char_one_total) && (char_three_total > char_four_total)
    // && (char_three_total > char_five_total)&& (char_three_total > char_six_total) && (char_three_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_three_total <<  ", Program response; " << endl
        << dataBaseSentence3;
/*______________________________________________________________________________________________*/
    //else if(char_four_total > char_two_total && (char_four_total > char_three_total) && (char_four_total > char_one_total)
    // && (char_four_total > char_five_total)&& (char_four_total > char_six_total) && (char_four_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_four_total <<  ", Program response; " << endl
        << dataBaseSentence4;
/*______________________________________________________________________________________________*/
    //else if(char_five_total > char_two_total && (char_five_total > char_three_total) && (char_five_total > char_four_total)
    // && (char_five_total > char_one_total)&& (char_five_total > char_six_total) && (char_five_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_five_total <<  ", Program response; " << endl
        << dataBaseSentence5;
/*______________________________________________________________________________________________*/
    //else if(char_six_total > char_two_total && (char_six_total > char_three_total) && (char_six_total > char_four_total)
    // && (char_six_total > char_five_total)&& (char_six_total > char_one_total) && (char_six_total > char_seven_total))

        cout << endl << endl << "Matching chars: " << char_six_total <<  ", Program response; " << endl
        << dataBaseSentence6;
/*______________________________________________________________________________________________*/
    //else if(char_seven_total > char_two_total && (char_seven_total > char_three_total) && (char_seven_total > char_four_total)
    // && (char_seven_total > char_five_total)&& (char_seven_total > char_six_total) && (char_seven_total > char_one_total))

        cout << endl << endl << "Matching chars: " << char_seven_total <<  ", Program response; " << endl
        << dataBaseSentence7;
}

void readSentence(std:: string direction, int amount){
    std::ofstream newLine("inputSentenceentence.txt", fstream::app);
    if (!newLine) { std::cerr<<"file error\n"; std::exit(1); }
    newLine << " " << direction << endl;
    newLine.close();
    std::ifstream fin1("inputSentenceentence.txt"), fin2("holdDatabase.txt");
    if (!fin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }

    string inputSentence;
    string dataBase;
    int count = 0;

    getline(fin1, inputSentence);

    while( getline( fin2, dataBase ) ){
        if(inputSentence == dataBase && count == 0){
            count++;
        }
        else if(inputSentence == dataBase && count > 0){
            count++;
        }
    }
    fin1.close();
    fin2.close();

    std::ofstream fout("holdDatabase.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    if(count == 0){
        fout << inputSentence << endl;
    }
    fout.close();
}

void writeSentence(std::string stringChar){

    std::ofstream fout("inputSentenceentence.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    if (stringChar[0] == ' ') {
        cout << stringChar[1];
        fout << stringChar[1];
    }
    else if (stringChar[0] != ' ') {
        cout << ' ' << stringChar[0];
        fout << ' ' << stringChar[0];
    }

    fout.close();
}

// This plays the sound


void playSound(std::string musicPattern, std::string stringChar){
    CMelody songSound;

    for (int i = 0; i < 9; ++i) {
        if(musicPattern == g_flat_pattern[i]){
            songSound.AddmusicPattern(g_flat_frequency_pattern[i], g_flat_duration[i]); // compare chord x
            writeSentence(stringChar);
            g_flat_direction_pattern[i];
        }
        if(musicPattern == d_flat_pattern[i]){
            songSound.AddmusicPattern(d_flat_frequency_pattern[i], d_flat_duration[i]); // compare chord h
            writeSentence(stringChar);
            d_flat_direction_pattern[i];
        }
        if(musicPattern == a_flat_pattern[i]){
            songSound.AddmusicPattern(a_flat_frequency_pattern[i], a_flat_duration[i]); // compare chord b
            writeSentence(stringChar);
            a_flat_direction_pattern[i];
        }
        if(musicPattern == e_flat_pattern[i]){
            songSound.AddmusicPattern(e_flat_frequency_pattern[i], e_flat_duration[i]); // compare chord s
            writeSentence(stringChar);
            e_flat_direction_pattern[i];
        }
        if(musicPattern == b_flat_pattern[i]){
            songSound.AddmusicPattern(b_flat_frequency_pattern[i], b_flat_duration[i]); // compare chord a
            writeSentence(stringChar);
            b_flat_direction_pattern[i];
        }
        if(musicPattern == F_pattern[i]){
            songSound.AddmusicPattern(F_frequency_pattern[i], F_duration[i]); // compare chord g
            writeSentence(stringChar);
            F_direction_pattern[i];
        }
        if(musicPattern == C_pattern[i]){
            songSound.AddmusicPattern(C_frequency_pattern[i], C_duration[i]); // compare chord l
            writeSentence(stringChar);
            C_direction_pattern[i];
        }
        if(musicPattern == G_pattern[i]){
            songSound.AddmusicPattern(G_frequency_pattern[i], G_duration[i]); // compare chord k
            writeSentence(stringChar);
            G_direction_pattern[i];
        }
        if(musicPattern == D_pattern[i]){
            songSound.AddmusicPattern(D_frequency_pattern[i], D_duration[i]); // compare chord u
            writeSentence(stringChar);
            D_direction_pattern[i];
        }
        if(musicPattern == A_pattern[i]){
            songSound.AddmusicPattern(A_frequency_pattern[i], A_duration[i]); // compare chord j
            writeSentence(stringChar);
            A_direction_pattern[i];
        }
        if(musicPattern == E_pattern[i]){
            songSound.AddmusicPattern(E_frequency_pattern[i], E_duration[i]); // compare chord r
            writeSentence(stringChar);
            E_direction_pattern[i];
        }
        if(musicPattern == B_pattern[i]){
            songSound.AddmusicPattern(B_frequency_pattern[i], B_duration[i]); // compare chord o
            writeSentence(stringChar);
            B_direction_pattern[i];
        }
	}
    songSound.Play();
}


// The music function is used to make the pattern.

void keyPattern(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_patternOne[] = {23, 18, 1, 7, 23, 7, 18, 1, 7};
	static const int frequency_patternTwo[] = {7, 0, 18, 1, 7, 1, 0, 18, 1};
	static const int frequency_patternThree[] = {1, 6, 0, 18, 1, 18, 6, 0, 18};
	static const int frequency_patternFour[] = {18, 11, 6, 0, 18, 0, 11, 6, 0};
	static const int frequency_patternFive[] = {0, 10, 11, 6, 0, 6, 10, 11, 6};
	static const int frequency_patternSix[] = {6, 20, 10, 11, 6, 11, 20, 10, 11};
	static const int frequency_patternSeven[] = {11, 9, 20, 10, 11, 10, 9, 20, 10};
	static const int frequency_patternEight[] = {10, 17, 9, 20, 10, 20, 17, 9, 20};
	static const int frequency_patternNine[] = {20, 14, 17, 9, 20, 9, 14, 17, 9};
	static const int frequency_patternTen[] = {9, 23, 14, 17, 9, 17, 23, 14, 17};
	static const int frequency_patternEleven[] = {17, 7, 23, 14, 17, 14, 7, 23, 14};
	static const int frequency_patternTwelve[] = {14, 1, 7, 23, 14, 23, 1, 7, 23};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternOne[i]]) {
            fout << g_flat_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternTwo[i]]) {
            fout << d_flat_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternThree[i]]) {
            fout << a_flat_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternFour[i]]) {
            fout << e_flat_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternFive[i]]) {
            fout << b_flat_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternSix[i]]) {
            fout << F_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternSeven[i]]) {
            fout << C_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternEight[i]]) {
            fout << G_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternNine[i]]) {
            fout << D_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternTen[i]]) {
            fout << A_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternEleven[i]]) {
            fout << E_pattern[i] << endl;
        }
		if (letterNumber == (i + 1) && frequency == frequencies[frequency_patternTwelve[i]]) {
            fout << B_pattern[i] << endl;
        }
    }

    fout.close();
}

// This allows me to read the csv file a line at a time, I got it from the internet
void readCSV(std::istream &input, std::vector< std::vector<std::string> > &output){
	std::string csvLine;
	// read every line from the stream
	while( std::getline(input, csvLine) ){
		std::istringstream csvStream(csvLine);
		std::vector<std::string> csvColumn;
		std::string csvElement;
		// read every element from the line that is seperated by commas
		// and put it into the vector or strings
		while( std::getline(csvStream, csvElement, ',') ){
			csvColumn.push_back(csvElement);
		}
		output.push_back(csvColumn);
	}
}

void openCsv(){

    int itemnum = 0;
    // I read the csv file and find the patterns then write the results to the pattern text file
    std::fstream file("file_out.csv", ios::in);
    if (!file) { std::cerr<<"file error\n"; std::exit(1); }

    // typedef to save typing for the following object
    typedef std::vector< std::vector<std::string> > csvVector;
    csvVector csvData;

    readCSV(file, csvData);
    // print out read data to prove reading worked
    for(csvVector::iterator I = csvData.begin(); I != csvData.end(); ++I){
        for(std::vector<std::string>::iterator J = I->begin(); J != I->end(); ++J){
            itemnum++;
            string T = *J;

            keyPattern(itemnum, T);
        }

    itemnum = 0;

    }
    // I close the csv file
    file.close();
}

int main()
{
    // The process of getting the input from the user.
    std::ofstream holdInputSentence("file_out.txt");
    if (!holdInputSentence) { std::cerr<<"file error\n"; std::exit(1); }
    char inputSentence[4096];
    cout << "Enter your sentence, end it with a period: ";
    cin.getline (inputSentence,4096);
    holdInputSentence << inputSentence;
    holdInputSentence.close();

    std::ifstream accessInput("file_out.txt");
    std::ofstream fin3("inputSentenceentence.txt");
    if (!accessInput || !fin3) { std::cerr<<"file error\n"; std::exit(1); }
    fin3.close();
    // The variables
    string accessInputString;
    string accessPatternString;
    string accessFrequencyChar;
    string musicPattern;
    string frequencyChar;
    vector<string> patternFile;
    int stringChar;
    int itemnum = 0;
    bool word = false;
    char letters[] = "abcdefghijklmnopqrstuvwxyz";
    float freqs[] = {466, 415, 415, 415, 415, 415, 349, 277,
    349, 440, 392, 261, 261, 349, 493, 261, 261, 329, 311,
    415, 293, 415, 311, 369, 392, 392};
    char *this_letter;
    int letter_index;

    // I convert the input to musical frequency values
    getline( accessInput, accessInputString );

    for (unsigned int a=0;a < accessInputString.length();a++){
        if ( accessInputString[a] == '.' || accessInputString[a] == '?' || accessInputString[a] == '!'){

            accessInputString[a] = '\n';
            // I open then close the file to erase the previous text
            std::ofstream pattern("pattern_file_out.txt");
            pattern.close();

            std::ifstream theInputString("file_out.txt");
            std::ofstream fout2("file_out.csv");
            std::ofstream fout_3("file_out_2.txt");
            if (!theInputString || !fout2 || !fout_3) { std::cerr<<"file error\n"; std::exit(1); }

            while ((stringChar = theInputString.get()) != EOF) {
                if (stringChar == '\'') continue; // skip apostrophe
                if (isalpha(stringChar)) {
                    if (word) fout_3<<" ";
                    if (word) fout2<<',';

                    if ((this_letter = strchr(letters, tolower(stringChar))) != NULL){
                        fout_3 << this_letter[0] << endl;
                        letter_index = this_letter - letters;
                        stringChar = freqs[letter_index];
                    }

                    fout2 << stringChar;
                    word = true;
                }

                else if (word) {
                    fout2<<'\n';
                    word = false;
                }
            }

            theInputString.close();
            fout2.close();
            fout_3.close();

        }
    }

    accessInput.close();

    // I write to pattern_file_out
    openCsv();

    // Now I take the text and make it into a sound using playSound.
    // playsound Calls writeSentence and displays the chars from inputChar.
    // This comment below is from playSound calling writeSentence.
    // Each time playSound gets a positive it has a int it can add one too.
    // This is how playSound adds to the count direction cout below.
    cout << endl << "Input sentence to program, from input.txt;" << endl;

    std::ifstream inputDesign("pattern_file_out.txt");
    std::ifstream inputChar("file_out_2.txt");
    if (!inputDesign || !inputChar) { std::cerr<<"file error\n"; std::exit(1); }

    while( getline( inputDesign, accessPatternString), getline( inputChar, accessFrequencyChar) ){
        musicPattern = accessPatternString;
        frequencyChar = accessFrequencyChar;

        playSound(musicPattern, frequencyChar);

        patternFile.push_back( accessPatternString );
    }

    inputDesign.close();
    inputChar.close();

    // readSentence looks at the string made by writeSentence to see if the strng is in the database file.
    // The string gets a int number besides it that matches the direction int value.
    // If the string is notin the database file it gets added it it along with its number value.

    if(count_up > count_upnD && (count_up > count_down) && (count_up > count_right_)
       && (count_up > count_left_) && (count_up > count_straight) && (count_up > count_around))

        readSentence("1", count_up);
/*______________________________________________________________________________________________*/
    else if(count_upnD > count_up && (count_upnD > count_down) && (count_upnD > count_right_)
            && (count_upnD > count_left_) && (count_upnD > count_straight) && (count_upnD > count_around))

        readSentence("2", count_upnD);
/*______________________________________________________________________________________________*/
    else if(count_down > count_upnD && (count_down > count_up) && (count_down > count_right_)
            && (count_down > count_left_) && (count_down > count_straight) && (count_down > count_around))

        readSentence("3", count_down);
/*______________________________________________________________________________________________*/
    else if(count_right_ > count_upnD && (count_right_ > count_down) && (count_right_ > count_up)
            && (count_right_ > count_left_) && (count_right_ > count_straight) && (count_right_ > count_around))

        readSentence("4", count_right_);
/*______________________________________________________________________________________________*/
    else if(count_left_ > count_upnD && (count_left_ > count_down) && (count_left_ > count_right_)
            && (count_left_ > count_up) && (count_left_ > count_straight) && (count_left_ > count_around))

        readSentence("5", count_left_);
/*______________________________________________________________________________________________*/
    else if(count_straight > count_upnD && (count_straight > count_down) && (count_straight > count_right_)
            && (count_straight > count_left_) && (count_straight > count_up) && (count_straight > count_around))

        readSentence("6", count_straight);
/*______________________________________________________________________________________________*/
    else if(count_around > count_upnD && (count_around > count_down) && (count_around > count_right_)
            && (count_around > count_left_) && (count_around > count_straight) && (count_around > count_up))

        readSentence("7", count_around);
/*______________________________________________________________________________________________*/

    // I open the string writeSentence made, and open the database.
    // I match the chars in the writeSentence string to the database string, every match adds one to a int variable.
    // The idea is the database strings have a number besides them so there is seven matches,
    // and so there can be a greatest match.
    // I want to display the greatest match but my if else conditions in the findmatch function don't work,
    // so I display every match.
    findMatch();
    cout << endl << endl;

    // I pause the console window so you can read the screen results
    system ("pause");
}
